
typedef struct variable variable;
struct variable
{
    char *name;
    char *value;
    struct variable *next;
};
 
typedef variable* llist;

llist mes_variables = NULL;

llist ajouterVariable(llist liste, char *nom, char *valeur)
{
    /* On crée un nouvel élément */
    variable* nouvelElement = malloc(sizeof(variable));
   //printf("%s",valeur);
    /* On assigne la valeur au nouvel élément */
    asprintf(&nouvelElement->name,nom);
    asprintf(&nouvelElement->value,valeur);
    //nouvelElement->name = nom;
    //nouvelElement->value = valeur;
 
    /* On assigne l'adresse de l'élément suivant au nouvel élément */
    nouvelElement->next = liste;
 
    /* On retourne la nouvelle liste, i.e. le pointeur sur le premier élément */
    return nouvelElement;
}

llist libererListeVariables(llist liste)
{
    variable* tmp = liste;
    variable* tmpnxt;
 
    /* Tant que l'on n'est pas au bout de la liste */
    while(tmp != NULL)
    {
        /* On stocke l'élément suivant pour pouvoir ensuite avancer */
        tmpnxt = tmp->next;
        /* On efface l'élément courant */
        free(tmp);
        /* On avance d'une case */
        tmp = tmpnxt;
    }
    /* La liste est vide : on retourne NULL */
    return NULL;
}

llist libererVariable(llist liste, char *nom)
{
    /* Liste vide, il n'y a plus rien à supprimer */
    if(liste == NULL)
        return NULL;
 
    /* Si l'élément en cours de traitement doit être supprimé */
    if(liste->name == nom){
        variable* tmp = liste->next;
        free(liste);
        tmp = libererVariable(tmp, nom);
        return tmp;
    }else{
        liste->next = libererVariable(liste->next, nom);
        return liste;
    }
}

void afficherListeVariables(llist liste)
{
    variable *tmp = liste;
    /* Tant que l'on n'est pas au bout de la liste */
    while(tmp != NULL)
    {
        /* On affiche */
        //printf("$[%s] == %s\n", tmp->name, tmp->value);
        /* On avance d'une case */
        tmp = tmp->next;
    }
}

char * afficherVariable(llist liste,  char *nom)
{
    variable *tmp=liste;
    /* Tant que l'on n'est pas au bout de la liste */
                                
    while(tmp != NULL)
    {
        
        if(strcmp(tmp->name,nom)==0)
        {
            //printf("--%s == %s\n",tmp->name, tmp->value);
            /* Si l'élément a la valeur recherchée, on renvoie son adresse */
            return tmp->value;
        }
        tmp = tmp->next;
    }
    char *env = getenv(nom);
    if (env == NULL) {
        return "";
    } else { return env; }
}




/* Convertit un nombre hexadecimal a deux "chiffres" en un caractere usuel */
char hex2dec(char s0, char s1) {
    int sum;
    if ((s1>=48)&&(s1<=57)) /* chiffre */
        sum=s1-48;
    else /* lettre */
        sum=s1-55;
    if ((s0>=48)&&(s0<=57)) /* chiffre */
        sum+=(s0-48)*16;
    else /* lettre */
        sum+=(s0-55)*16;
    return sum;
}

/* Extrait la chaine de caracteres renvoyee par CGI */
int GetCGIString(char *pszCGIString) {
    char *pszTemp;

    pszTemp=getenv("REQUEST_METHOD");

    if(strcmp(pszTemp,"GET")==0){
        pszTemp=getenv("QUERY_STRING");
        if(strlen(pszTemp)<LG_MAX){
            strcpy(pszCGIString,pszTemp);
            return 1;
        }else{
            printf("Erreur : taille de chaine %zu superieure a la longueur max %d. \n",strlen(pszTemp),LG_MAX);
            return 0;
        }
    }else{
        if(strcmp(pszTemp,"POST")==0){
            if(atoi(getenv("CONTENT_LENGTH"))<LG_MAX){
                scanf("%s",pszCGIString);
                return 1;
            }else{
                printf("Erreur : taille de chaine %d superieure a la longueur max %d. \n",atoi(getenv("CONTENT_LENGTH")),LG_MAX);
                return 0;
            }
        }else{
            printf("Methode CGI non supportee. \n");
            return 0;
        }
    }
}


/* Remplace les "+" et les "%xx" de la chaine CGI */
void CleanCGIString(char *pszString) {
    int iSrc=0; 
    int iDest=0; 
    do {
        while ((pszString[iSrc])&&(pszString[iSrc]!='%'))
            if (pszString[iSrc]!='+')
                pszString[iDest++]=pszString[iSrc++];
            else { 
                pszString[iDest++]=' ';
                iSrc++;
            } 

        if (pszString[iSrc]){
            pszString[iDest++]=hex2dec(pszString[iSrc+1],pszString[iSrc+2]);
            iSrc+=3; 
        }
    } while (pszString[iSrc]);

    pszString[iDest]=0; 
}

/* Decoupe la chaine CGI en ses differents arguments */
int ParseCGIString(char *pszCGIString,char *pszResult) {
    char pszTemp[LG_MAX], *pszString, *pszPointer;
    int iLength;

    iLength=strlen(pszCGIString);
    if(iLength>0 && iLength<LG_MAX){
        pszString=pszCGIString;
        pszPointer=pszTemp;
        if(*pszString!=0){
            if(*pszString=='=' && *(pszString+1)==0){
                pszString++;
                *pszResult=0;
            }
            while(*pszString!='=' && *pszString!='&' && *pszString!=0) *(pszPointer++)=*(pszString++);
            if(*pszString=='=' || *pszString=='&' || (*pszString==0 && pszPointer!=pszTemp)){
                *pszPointer=0;
                pszPointer=pszTemp;
                if(*pszString && !(*pszString=='=' && *(pszString+1)==0)) pszString++;
                CleanCGIString(pszTemp);
                strcpy(pszResult,pszTemp);
            }
        }
        strcpy(pszCGIString,pszString);
        return 1;
    }else{
        if(iLength>0) printf("Erreur : taille de chaine %d superieure a la longueur max %d. \n",iLength,LG_MAX);
        return 0;
    }
}

/* Remplace les '<' et '>' de la chaine en vue de l'affichage dans un browser */
void BeforePrintingCGIString(char *pszString){
    char pszTemp[LG_MAX];
    int iSrc, iDest;

    iSrc=0;
    iDest=0;
    while(pszString[iSrc]!=0 && iDest<LG_MAX){
        while(pszString[iSrc]!='<' && pszString[iSrc]!='>' && pszString[iSrc]!=0 && iDest<LG_MAX)
            pszTemp[iDest++]=pszString[iSrc++];

        if(pszString[iSrc]=='<'){
            iSrc++;
            if(iDest<(LG_MAX-5)){
                pszTemp[iDest++]='&';
                pszTemp[iDest++]='#';
                pszTemp[iDest++]='6';
                pszTemp[iDest++]='0';
            }
        }
        if(pszString[iSrc]=='>'){
            iSrc++;
            if (iDest<(LG_MAX-5)) {
                pszTemp[iDest++]='&';
                pszTemp[iDest++]='#';
                pszTemp[iDest++]='6';
                pszTemp[iDest++]='2';
            }
        }
    }
    pszTemp[iDest]=0;
    strcpy(pszString,pszTemp);
}
